VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "  XML (MSXML)"
   ClientHeight    =   4095
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7215
   LinkTopic       =   "Form1"
   ScaleHeight     =   4095
   ScaleWidth      =   7215
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   1215
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "Form1.frx":0000
      Top             =   240
      Width           =   2295
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'   xml  msxml
' BV, borisvorontsov@gmail.com
':    msxml  2.6,      

Private Const XML_FILE As String = "settings.xml"

Private Sub Form_Load()
    Call LoadSettingsFromXML
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Call SaveSettingsToXML
End Sub

Private Sub Form_Resize()
    Text1.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
End Sub

Private Sub SaveSettingsToXML()
    Dim objXMLDoc As New DOMDocument
    Dim objRootNode As IXMLDOMNode, objCurrentNode As IXMLDOMNode
    
    '  
    Set objRootNode = objXMLDoc.createNode(NODE_ELEMENT, "settings", "")
    Call objXMLDoc.appendChild(objRootNode)

    If Me.WindowState = vbNormal Then
        ' ,   
        Set objCurrentNode = objXMLDoc.createNode(NODE_ELEMENT, "form_size", "")
    
        '      
        objCurrentNode.Attributes.setNamedItem(objXMLDoc.createAttribute("left")).Text = Str$(Me.Left)
        objCurrentNode.Attributes.setNamedItem(objXMLDoc.createAttribute("top")).Text = Str$(Me.Top)
        objCurrentNode.Attributes.setNamedItem(objXMLDoc.createAttribute("width")).Text = Str$(Me.Width)
        objCurrentNode.Attributes.setNamedItem(objXMLDoc.createAttribute("height")).Text = Str$(Me.Height)
    
        Call InsertWhiteSpace(objRootNode, vbCrLf + vbTab)
        Call objRootNode.appendChild(objCurrentNode)
        Call InsertWhiteSpace(objRootNode, vbCrLf + vbTab)
    End If

    ' ,      
    Set objCurrentNode = objXMLDoc.createNode(NODE_ELEMENT, "text", "")
    objCurrentNode.Attributes.setNamedItem(objXMLDoc.createAttribute("text_length")).Text = Str$(Len(Text1.Text))
    objCurrentNode.Text = Text1.Text
    
    Call objRootNode.appendChild(objCurrentNode)
    Call InsertWhiteSpace(objRootNode)
    
    Call objXMLDoc.save(XML_FILE)
End Sub

'  xml  ( ,  )
'  ,     / xml-   
Private Sub InsertWhiteSpace(ByVal objNode As IXMLDOMNode, Optional ByVal strWS As String = vbCrLf)
    Dim objWhiteSpace As IXMLDOMText
    Set objWhiteSpace = objNode.ownerDocument.createTextNode(strWS)
    Call objNode.appendChild(objWhiteSpace)
    Set objWhiteSpace = Nothing
End Sub

Private Sub LoadSettingsFromXML()
    Dim objXMLDoc As New DOMDocument
    Dim objRootNode As IXMLDOMNode, objCurrentNode As IXMLDOMNode
    
    objXMLDoc.async = False
    objXMLDoc.validateOnParse = False
    If Not objXMLDoc.Load(XML_FILE) Then
        Err.Raise objXMLDoc.parseError.errorCode, , objXMLDoc.parseError.reason
    End If

    Set objRootNode = objXMLDoc.selectSingleNode("settings")
    '       
    Set objCurrentNode = objRootNode.selectSingleNode("form_size")
    With Me
        .Left = Val(objCurrentNode.Attributes.getNamedItem("left").Text)
        .Top = Val(objCurrentNode.Attributes.getNamedItem("top").Text)
        .Width = Val(objCurrentNode.Attributes.getNamedItem("width").Text)
        .Height = Val(objCurrentNode.Attributes.getNamedItem("height").Text)
    End With
    
    '       
    Text1.Text = Replace(objRootNode.selectSingleNode("text").Text, vbLf, vbCrLf)
End Sub
